首先可以二分答案,将最优性问题转化为判定性问题。

  对于二分到的边长,我们可以把所有的点看成一个大的矩形,这个矩形为包括所有点的最小矩形,那么贪心的想,3个正方形,第一个肯定放在这个矩形其中的一角,然后去掉覆盖的点,然后再求出一个矩形,然后再枚举放在哪一角,去掉之后判断剩下的是否可以由一个正方形覆盖就行了。

  反思:没画图,边界算的不对,而且枚举完两个正方形之后要判下是否没有没覆盖的点了。另外提供神样例 4 1 1 -1 -1 1 -1 -1 1答案是2。

/**************************************************************
    Problem: 1052
    User: BLADEVIL
    Language: C++
    Result: Accepted
    Time:1484 ms
    Memory:1280 kb
****************************************************************/
 
//By BLADEVIL
#include <cstdio>
#include <cstring>
#include <algorithm>
#define maxn 20010
#define inf (~0U>>1)
 
using namespace std;
 
struct rec {
    int x,y,flag;
    rec(){
        x=y=flag=;
    }
}a[maxn],b[maxn];
 
int n;
 
bool cmp(rec x,rec y) {
    return (x.flag<y.flag);
}
 
void update(rec &MAX,rec &MIN) {
    MAX.x=MAX.y=-inf;
    MIN.x=MIN.y=inf;
    for (int i=;(i<=n)&&(!b[i].flag);i++) {
        MAX.x=max(MAX.x,b[i].x);
        MIN.x=min(MIN.x,b[i].x);
        MAX.y=max(MAX.y,b[i].y);
        MIN.y=min(MIN.y,b[i].y);
    }
}
 
void make(int x,int len) {
    rec MAX,MIN;
    update(MAX,MIN);
    //printf("%d %d %d %d\n",MAX.x,MAX.y,MIN.x,MIN.y);
    int up,down,left,right;
    if (x==) {
        up=MAX.y; left=MIN.x;
        down=up-len; right=left+len;
    }
    if (x==) {
        up=MIN.y+len; left=MIN.x;
        right=left+len; down=MIN.y;
    }
    if (x==) {
        right=MAX.x; left=right-len;
        down=MIN.y; up=down+len;
    }
    if (x==) {
        up=MAX.y; down=up-len;
        right=MAX.x; left=right-len;
    }
    //printf("%d %d %d %d %d\n",x,left,right,up,down); 
    for (int i=;i<=n;i++) if ((b[i].x<=right)&&(b[i].x>=left)&&(b[i].y<=up)&&(b[i].y>=down)) b[i].flag=;
}
 
bool work(int i,int j,int x) {
    memcpy(b,a,sizeof a);
    make(i,x);
    sort(b+,b++n,cmp);
    make(j,x);
    sort(b+,b++n,cmp);
    rec MAX,MIN;
    update(MAX,MIN);
    int left=MIN.x,right=MAX.x,up=MAX.y,down=MIN.y;
    //printf("%d %d %d %d %d\n",x,left,right,up,down);
    if ((left==inf)&&(right==-inf)&&(up==-inf)&&(down==inf)) return ;
    if ((MAX.x-MIN.x<=x)&&(MAX.y-MIN.y<=x)) return ; else return ;
}
 
bool judge(int x) {
    for (int i=;i<=;i++)
        for (int j=;j<=;j++) if (i!=j) if (work(i,j,x)) return ;
    return ;
}
 
int main() {
    scanf("%d",&n);
    for (int i=;i<=n;i++) scanf("%d%d",&a[i].x,&a[i].y);
    //printf("%d\n",work(1,2,1)); return 0;
    int l=,r=1e9,ans=;
    while (l<=r) {
        //printf("%d %d\n",l,r);
        int mid=l+r>>;
        if (judge(mid)) ans=mid,r=mid-; else l=mid+;
    }
    printf("%d\n",ans);
    return ;
}

bzoj 1052 dfs的更多相关文章

  1. BZOJ 1052: [HAOI2007]覆盖问题

    BZOJ 1052: [HAOI2007]覆盖问题 题意:给定平面上横纵坐标在-1e9~1e9内的20000个整数点的坐标,用三个大小相同边平行于坐标轴的正方形覆盖(在边界上的也算),问正方形的边长最 ...

  2. 二分判定 覆盖问题 BZOJ 1052

    //二分判定 覆盖问题 BZOJ 1052 // 首先确定一个最小矩阵包围所有点,则最优正方形的一个角一定与矩形一个角重合. // 然后枚举每个角,再解决子问题 #include <bits/s ...

  3. BZOJ 1052 HAOI2007 覆盖问题 二分法答案+DFS

    标题效果:特定n点.涵盖所有的点与同方三面.斧头要求方垂直边界,最小平方的需求方长值 最大值至少.答案是很明显的二分法 但验证是一个问题 考虑仅仅有三个正方形,故用一个最小矩形覆盖这三个正方形时至少有 ...

  4. BZOJ 1052 覆盖问题

    Description 某人在山上种了N棵小树苗.冬天来了,温度急速下降,小树苗脆弱得不堪一击,于是树主人想用一些塑料薄膜把这些小树遮盖起来,经过一番长久的思考,他决定用3个L*L的正方形塑料薄膜将小 ...

  5. [BZOJ 1052][HAOI2007]覆盖问题(二分答案)

    题目:http://www.lydsy.com:808/JudgeOnline/problem.php?id=1052 分析: 挺有想法的一道题,先二分答案ans,主要是判断的问题. 首先可以弄出把所 ...

  6. bzoj 4034(DFS序+线段树)

    这个题多了一个操作难度直线上升,看完题解才会写 有一棵点数为 N 的树,以点 1 为根,且树点有边权.然后有 M 个操作,分为三种:操作 1 :把某个节点 x 的点权增加 a .操作 2 :把某个节点 ...

  7. bzoj 2819(DFS序+树状数组+博弈+lca)

    2819: Nim Time Limit: 20 Sec  Memory Limit: 128 MBSubmit: 2045  Solved: 795[Submit][Status][Discuss] ...

  8. bzoj 1225 dfs + 一点点数论

    思路:有一个公式  如果 x = a1 ^ b1 * a2 ^ b2 * ...... * an ^ bn 其中ai为质数,那么总共的因子个数为 (b1 + 1) * (b2 + 1) *....* ...

  9. 【以前的空间】bzoj 1052 [HAOI2007]覆盖问题

    这道题的思路挺简单的……就是可以证明如果要覆盖一个区域内的点,那么一定有一个正方形在这“区域内的点所围成的最大矩形的四个角中的一个”(不要吐槽很多的“的”……),对于长度r是否可以覆盖整个区域内的点, ...

随机推荐

  1. YaoLingJump开发者日志(九)V1.1.1版本完成

    跳跃吧瑶玲下载连接 百度网盘下载 介绍   Android版本升级到8.0,发现原来的图标不显示了:   百度了一下解决方案,用了该博客提供的第二种方法,修改roundIcon的内容.   可爱的图标 ...

  2. HDU 2163 Palindromes

    http://acm.hdu.edu.cn/showproblem.php?pid=2163 Problem Description Write a program to determine whet ...

  3. C# lamda表达式

    using System; using System.Collections.Generic; using System.Linq; using System.Text; using System.T ...

  4. java 基础 --多态--009

    1, 多态:同一个对象(事物),在不同时刻体现出来的不同状态 2, 多态的前提: A: 要有继承关系 B: 要有方法的重写 C: 要有父类引用指向子类对象 父 f = new 子(); 3, 多态访问 ...

  5. asp.net MVC4在Action间跳转 RedirectToAction 传值参数问题

    return RedirectToAction("Test", new { cw = cw, firstdirectoryid = firstdirectoryid }); 上式中 ...

  6. RT-thread-2.0.1移植(基于STM32F4xx)

    1.将下载的rt-thread-2.0.1解压后,得到如下图所示的文件列表. 在bsp目录下可以找到stm32f40x文件夹,这文件夹里面包括了库函数,其他芯片平台的文件夹统统删掉.在libcpu下, ...

  7. Windows系统Unity3D中的快捷键

    Windows系统Unity3D中的快捷键 组合键 键 功能 File 文件 Ctrl   N New Scene 新建场景 Ctrl   O Open Scene 打开场景 Ctrl   S Sav ...

  8. Oracle 分页、取期间数据、TOP前几

    Oracle没有 sqlserver的 top number 功能.只能以期间的形式实现 代码实现分页,参数curPage 当前页.pageSize 每页行数,计算出起始结束页码 int startP ...

  9. bzoj 3217: ALOEXT

    将此神题作为博客园的第一篇文章,至此,数据结构基本学完了(或者说数据结构轮流虐了我一次!) 人生第一道7K代码题! 没什么,就是treap套个trie,然后tle是因为一定要用指针当时p党谁会用那么丑 ...

  10. [SDOI2015]约数个数和 莫比乌斯反演

    ---题面--- 题解: 为什么SDOI这么喜欢莫比乌斯反演,,, 首先有一个结论$$d(ij) = \sum_{x|i}\sum_{y|j}[gcd(x, y) == 1]$$为什么呢?首先,可以看 ...